//*******************************************************************************
// file  sample.c
//
// attention
// Copyright (C) 2018 MACNICA,Inc. All Rights Reserved.\n
//   This software is licensed "AS IS". 
//   Please perform use of this software by a user's own responsibility and expense.
//   It cannot guarantee in the maker side about the damage which occurred by the ab-
//   ility not to use or use this software, and all damage that occurred secondarily.
//*******************************************************************************

/*******************************************************************************
 *  WEXLb^MU DMAimSGDMAjɂ郁ԓ]Tv
 *******************************************************************************/
/****************************
 *  CN[hEt@C
 ****************************/
#include "system.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/alt_cache.h>
#include <sys/alt_irq.h>

// mSGDMA ]֘A
#include <altera_msgdma_descriptor_regs.h>
#include <altera_msgdma_csr_regs.h>
#include <altera_msgdma.h>

/*******************************************************************************
 *  re-definitions
 *   ̃ZNV "system.h" Œ`ꂽ萔A
 *     {\[Xt@CŎgp邽߂ɍĒ`̂łB
 *     gp̍ۂ͉E̒萔 "system.h" QƂ̏AύXĂgB
 *******************************************************************************/
#define MSGDMA_NAME (MSGDMA_CSR_NAME)   // mSGDMA ̃WX^
#define OCRAM0_BASE (OCRAM_0_BASE)      // I`bv RAM 0 ̃x[XAhX
#define OCRAM1_BASE (OCRAM_1_BASE)      // I`bv RAM 1 ̃x[XAhX

/****************************
 *  }N`
 ****************************/
#define TRUE                -1
#define FALSE               0

#define USE_ASYNC_XFER  TRUE    // DMA ] :  TRUE = alt_msgdma_standard_descriptor_async_transfer() gp
                                //            FALSE = alt_msgdma_standard_descriptor_sync_transfer() gp
#define XFER_BYTES      1024    // DMA ]̃TCYioCgPʁj: 1KByte

/****************************
 *  O[oϐ
 ****************************/
volatile int xfer_cmp = FALSE;  // ]tO
volatile int xfer_err = FALSE;  // ]G[tO

/****************************
 *  vg^Cv錾
 ****************************/
void msgdma_callback( void* context );                                              // mSGDMA ]R[obN֐
void init_ram( unsigned char *p_rd_adrs, unsigned char *p_wr_adrs, int bytes );     // RAM f[^֐
void dump_ram( unsigned char *p_ram_adrs, int bytes );                              // RAM f[^E_v֐
int verify_ram( unsigned char *p_rd_adrs, unsigned char *p_wr_adrs, int bytes );    // RAM f[^Ext@C֐

/****************************
 *  ֐
 ****************************/
/********************************************
 *  main ֐
 */
int main()
{
    alt_msgdma_dev *p_msgdma;                   // mSGDMA CX^Xւ̃|C^
    alt_msgdma_standard_descriptor msgdma_desc; // X^_[hEfBXNv^\̂ւ̃|C^
    unsigned char *p_dma_rd;                    // DMA ]AhX̃|C^
    unsigned char *p_dma_wr;                    // DMA ]AhX̃|C^
    int status = 0;

    // DMA ]AhX̃|C^ (LbV̈Ń|C^)
    p_dma_rd = (unsigned char*)( OCRAM0_BASE | 0x80000000 );
    // DMA ]AhX̃|C^ (LbV̈Ń|C^)
    p_dma_wr = (unsigned char*)( OCRAM1_BASE | 0x80000000 );

    printf("<< Start Program!! >>\n");

    //===================================================
    // I`bv RAM ̃f[^
    //===================================================

    // ]I`bv RAM  DMA ]TCỸ_Ef[^
    // ]I`bv RAM  DMA ]TCYNA
    init_ram( p_dma_rd, p_dma_wr, XFER_BYTES );

    //===================================================
    // DMA ]ÕI`bv RAM f[^_v\
    //===================================================

    // ]I`bv RAM f[^_v\
    printf( "\n<Debug> On-Chip RAM 0 Contents Before DMA!!\n" );
    dump_ram( p_dma_rd, XFER_BYTES );

    // ]I`bv RAM f[^_v\
    printf( "\n<Debug> On-Chip RAM 1 Contents Before DMA!!\n" );
    dump_ram( p_dma_wr, XFER_BYTES );

    //===================================================
    // DMA ]̎s
    //===================================================

    // mSGDMA CX^Xւ̃|C^擾
    p_msgdma = alt_msgdma_open( MSGDMA_NAME );
    if ( p_msgdma == NULL )
    {
        printf( "Error: Could not open the mSGDMA\n" );
        return -1;
    }

    // alt_msgdma_irq() R[obN mSGDMA ]R[obN֐o^
    alt_msgdma_register_callback( p_msgdma, 
                                  msgdma_callback, 
                                  ALTERA_MSGDMA_CSR_GLOBAL_INTERRUPT_MASK | 
                                  ALTERA_MSGDMA_CSR_STOP_ON_ERROR_MASK | 
                                  ALTERA_MSGDMA_CSR_STOP_ON_EARLY_TERMINATION_MASK, 
                                  p_msgdma );

    // LbVEtbV
    alt_dcache_flush_all();

    // DMA fBXNv^\
    status = alt_msgdma_construct_standard_mm_to_mm_descriptor( p_msgdma, 
                                                                &msgdma_desc, 
                                                                (alt_u32*)p_dma_rd, 
                                                                (alt_u32*)p_dma_wr, 
                                                                XFER_BYTES, 
                                                                ALTERA_MSGDMA_DESCRIPTOR_CONTROL_TRANSFER_COMPLETE_IRQ_MASK );
    if( status != 0 )
    {
        printf( "Error: mSGDMA descriptor Fail[%d]\n", status );
        return status;
    }

    // DMA ]Jn
    printf( "\n<Debug> mSGDMA Transfer Start!!\n" );
#if USE_ASYNC_XFER
    status = alt_msgdma_standard_descriptor_async_transfer( p_msgdma, &msgdma_desc );
    if ( 0 != status )
    {
        printf( "Error: mSGDMA async_transfer Fail[%d]\n", status );
        return status;
    }
    // ]iR[obNj҂[v
    while (1)
    {
        // ]ł΃[v𔲂
        if ( xfer_cmp == TRUE )
            break;
        // mSGDMA ]G[oĂ΃[v𔲂
        if ( xfer_err )
            break;
    }
#else
    status = alt_msgdma_standard_descriptor_sync_transfer( p_msgdma, &msgdma_desc );
    if ( 0 != status )
    {
        printf( "Error: mSGDMA sync_transfer Fail[%d]\n", status );
        return status;
    }
#endif

    //===================================================
    // DMA ]̃I`bv RAM f[^_v\
    //===================================================

    // ]I`bv RAM f[^_v\
    printf( "\n<Debug> On-Chip RAM 0 Contents After DMA!!\n" );
    dump_ram( p_dma_rd, XFER_BYTES );

    // ]I`bv RAM f[^_v\
    printf( "\n<Debug> On-Chip RAM 1 Contents After DMA!!\n" );
    dump_ram( p_dma_wr, XFER_BYTES );

    //===================================================
    // DMA ]̃I`bv RAM f[^xt@C
    //===================================================

    printf( "\n<Debug> On-Chip RAM 0 and 1 Contents Verify!!\n" );
    status = verify_ram( p_dma_rd, p_dma_wr, XFER_BYTES );
    if ( 0 != status )
        printf( "<Debug> Data Verify Error!!\n" );
    else
        printf( "<Debug> Data Verify OK!!\n" );

    return status;
}

/********************************************
 *  mSGDMA ]R[obN֐
 *
 *	F   [U`ReLXgւ̃|C^
 *	߂lF 
 */
void msgdma_callback( void* context )
{
    struct alt_msgdma_dev *p_msgdma = (alt_msgdma_dev*)context;

    printf( "<Debug> mSGDMA Callback Function called!!\n" );

    // mSGDMA  Rg[EWX^  Xe[^XEWX^ ̒l擾
    int nCtrl = IORD_ALTERA_MSGDMA_CSR_CONTROL( p_msgdma->csr_base );
    int nStat = IORD_ALTERA_MSGDMA_CSR_STATUS( p_msgdma->csr_base );

    // woCg]?
    if ( nStat & ALTERA_MSGDMA_CSR_DESCRIPTOR_BUFFER_EMPTY_MASK )
    {
        // Yes: ]tO𗧂Ă
        xfer_cmp = TRUE;
    }
    else
    {
        // ȊO̊荞݂̓G[Ƃ
        xfer_err = TRUE;
        printf( " mSGDMA_IRQ: stat_reg=%X. ctrl_reg=%X\n", nStat, nCtrl );
    }
}

/********************************************
 *  RAM f[^֐
 *
 *	F *p_rd_adrs - ] RAM ̃AhXE|C^
 *         *p_wr_adrs - ] RAM ̃AhXE|C^
 *              bytes - ]oCg
 *	߂lF 
 */
void init_ram( unsigned char *p_rd_adrs, unsigned char *p_wr_adrs, int bytes )
{
    int i;

    for ( i = 0; i < bytes; i++ )
    {
        // ] RAM  DMA ]TCỸ_Ef[^
        p_rd_adrs[i] = rand();
    }
    // ] RAM  DMA ]TCYNA
    memset( p_wr_adrs, 0x00, bytes );
}

/********************************************
 *  RAM f[^E_v֐
 *
 *	F *p_ram_base - RAM ̃AhXE|C^
 *               bytes - ]oCgi_voCgj
 *	߂lF 
 */
void dump_ram( unsigned char *p_ram_adrs, int bytes )
{
    int i;
    unsigned char ucData;

    // LbVEtbV
    alt_dcache_flush_all();

    printf( "\n0000: " );
    for ( i = 0; i < bytes; i++ )
    {
        ucData = p_ram_adrs[i];
        if(( i % 16 == 15 ) && ( i < bytes - 1 ))
            printf( "%02X \n%04X: ", ucData, i + 1 );
        else
            printf( "%02X ", ucData );
    }
    printf( "\n" );
}

/********************************************
 *  RAM f[^Ext@C֐
 *
 *	F *p_rd_adrs - ] RAM ̃AhXE|C^
 *         *p_wr_adrs - ] RAM ̃AhXE|C^
 *              bytes - ]oCg
 *	߂lF 0 = G[A -1 = xt@CEG[
 */
int verify_ram( unsigned char *p_rd_adrs, unsigned char *p_wr_adrs, int bytes )
{
    int i;
    int status = 0;

    for ( i = 0; i < bytes; i++ )
    {
        if ( p_rd_adrs[i] != p_wr_adrs[i] )
        {
            printf( "<Debug> Data Verify Error!! Address = %05d\n", (unsigned int)i );
            status = -1;
        }
    }
    return status;
}
